"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const fs = require("mz/fs");
const yaml = require("js-yaml");
function read(yamlPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const rawYaml = yield fs.readFile(yamlPath, 'utf8');
        return yaml.safeLoad(rawYaml);
    });
}
exports.read = read;
function write(yamlPath, yamlObj) {
    const rawYaml = yaml.safeDump(yamlObj, { sortKeys: true });
    return fs.writeFile(yamlPath, rawYaml, 'utf8');
}
exports.write = write;
//# sourceMappingURL=yamlfs.js.map