"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const execa = require("execa");
const createPkgId_1 = require("./createPkgId");
const hostedGitInfo = require("@zkochan/hosted-git-info");
// TODO: resolve ref to commit
function resolveGit(parsedSpec, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const parts = normalizeRepoUrl(parsedSpec.spec).split('#');
        const repo = parts[0];
        const ref = parts[1] || 'master';
        const commitId = yield resolveRef(repo, ref);
        return {
            id: repo
                .replace(/^.*:\/\/(git@)?/, '')
                .replace(/:/g, createPkgId_1.delimiter)
                .replace(/\.git$/, '') + '/' + commitId,
            repo,
            commitId,
        };
    });
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = resolveGit;
function resolveRef(repo, ref) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield execa('git', ['ls-remote', '--refs', repo, ref]);
        // should output something like:
        //   572bc3d4e16220c2e986091249e62a5913294b25    	refs/heads/master
        // if no ref was found, assume that ref is the commit ID
        if (!result.stdout)
            return ref;
        return result.stdout.match(/^[a-z0-9]+/);
    });
}
function normalizeRepoUrl(repoUrl) {
    const hosted = hostedGitInfo.fromUrl(repoUrl);
    if (!hosted)
        return repoUrl;
    return hosted.getDefaultRepresentation() == 'shortcut' ? hosted.git() : hosted.toString();
}
//# sourceMappingURL=git.js.map